package com.agentfactory.afapl.debugger;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.afapl.interpreter.Commitment;
import com.agentfactory.afapl.interpreter.Utilities;
import com.agentfactory.clf.plans.IPlanStep;
import com.agentfactory.clf.reasoner.Bindings;

public class CommitmentDescription {
	public String current;
	public List<String> stack;
	public Bindings bindings;
	public String state;
	
	public CommitmentDescription(Commitment commitment) {
		if (commitment.getCurrent() != null) {
			current = commitment.getCurrent().toString();
//			System.out.println("current: " + current);
		}
		stack = new LinkedList<String>();
		for (IPlanStep step: commitment.getStack()) {
//			System.out.println("step: " + step);
			stack.add(step.toString());
		}
		bindings = commitment.bindings().merge(new Bindings());
		state = commitment.stateString();
	}
	
	@Override
	public String toString() {
		String output = Utilities.presenter.toString(bindings) + " -> [" + state + "]";
//		output += this.current;
		for (String step: stack) {
			output+="\n" + step;
		}
		return output + ";";
	}
}
