package com.agentfactory.afapl.debugger;

import java.util.List;

import com.agentfactory.afapl.interpreter.GoalHandler;
import com.agentfactory.afapl.interpreter.Plan;
import com.agentfactory.afapl.interpreter.Utilities;

public class GoalDescription {
	String goal;
	List<Plan> options;
	Plan current;
	CommitmentDescription commitment;
	
	public GoalDescription(GoalHandler handler) {
		this.goal = Utilities.presenter.toString(handler.goal());
		this.options = handler.options();
		this.current = handler.current();
		if (handler.commitment() != null) {
			this.commitment = new CommitmentDescription(handler.commitment());
		}
	}
	
	public String toString() {
    	String text = "";
        text += "Goal: " + goal + "\n";
        text += "Commitment:\n" + commitment + "\n";
        text += "Current:\n" + current + "\n";
        text += "Options:\n";
        if (options == null) {
        	text += "none generated\n";
        } else {
	        for (Plan option : options) {
	        	text += option + "\n";
	        }
        }
		return text;
	}
}
