package com.agentfactory.afapl.interpreter;

import java.util.List;

import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.lang.Unifier;
import com.agentfactory.clf.reasoner.Bindings;
import com.agentfactory.clf.reasoner.IQueryable;
import com.agentfactory.clf.reasoner.ResolutionBasedQueryEngine;

public class AFAPLResolutionBasedQueryEngine extends ResolutionBasedQueryEngine {

    public boolean handleSpecialCase(StackEntry entry, IFormula formula) {
    	if (Goal.class.isInstance(formula)) {
        	Goal goal = (Goal) formula;
//    		System.out.println("checking goal: " + Utilities.presenter.toString(goal));
            List<IFormula> matchingFormulae = getMatchingFormula(goal);
            for(IFormula next:matchingFormulae) {
                if (Goal.class.isInstance(next)) {
                	Goal nextMatch = (Goal) next;
//            		System.out.println("next: " + Utilities.presenter.toString(nextMatch));
//            		System.out.println("test: " + CoreUtilities.presenter.toString(nextMatch));
                    List<Bindings> labelBindings = generateLabelBindings((Predicate) goal.formula(), (Predicate) nextMatch.formula());
                    if (!labelBindings.isEmpty()) {
                    	for (Bindings binding : labelBindings) {
                    		Bindings b1 = Unifier.unifyFormulae((Predicate) goal.formula(), (Predicate) nextMatch.formula().apply(binding));
//                    		System.out.println("b1: " + CoreUtilities.presenter.toString(b1));
                    		if(b1 != null) {
                    			StackEntry se = entry.copy(b1.merge(binding));
                    			possibleSolutions.add(se);
                    		}
                    	}
                    } else if (((Predicate) goal.formula()).getLabels().isEmpty()) {
                		Bindings b1 = Unifier.unifyFormulae((Predicate) goal.formula(), (Predicate) nextMatch.formula());
//                		System.out.println("b1: " + CoreUtilities.presenter.toString(b1));
                		if(b1 != null) {
                			StackEntry se = entry.copy(b1);
                			possibleSolutions.add(se);
                		}
                    }
                } else {
                    throw new RuntimeException("Fatal Error in Query Engine: attempt to match: " + next);
                }
            }
    		return true;
    	}
    	return false;
    }

    protected ResolutionBasedQueryEngine spawn() {
        ResolutionBasedQueryEngine engine = new AFAPLResolutionBasedQueryEngine();
        for (IQueryable source: sources) {
            engine.addSource(source);
        }
        return engine;
    }
}
