/*
 * ClassCheckVisitor.java
 *
 * Created on 19 June 2006, 11:46
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler;

import java.io.PrintWriter;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.agentfactory.afapl2.compiler.parser.Visitor;
import com.agentfactory.afapl2.compiler.parser.node.ActionNode;
import com.agentfactory.afapl2.compiler.parser.node.ActivityNode;
import com.agentfactory.afapl2.compiler.parser.node.AlwaysNode;
import com.agentfactory.afapl2.compiler.parser.node.AndNode;
import com.agentfactory.afapl2.compiler.parser.node.BeliefNode;
import com.agentfactory.afapl2.compiler.parser.node.ClassNode;
import com.agentfactory.afapl2.compiler.parser.node.CommitNode;
import com.agentfactory.afapl2.compiler.parser.node.EqualNode;
import com.agentfactory.afapl2.compiler.parser.node.FOSNode;
import com.agentfactory.afapl2.compiler.parser.node.FunctionNode;
import com.agentfactory.afapl2.compiler.parser.node.GoalNode;
import com.agentfactory.afapl2.compiler.parser.node.GreaterThanNode;
import com.agentfactory.afapl2.compiler.parser.node.ImpliesNode;
import com.agentfactory.afapl2.compiler.parser.node.LessThanNode;
import com.agentfactory.afapl2.compiler.parser.node.ModalNode;
import com.agentfactory.afapl2.compiler.parser.node.ModuleNode;
import com.agentfactory.afapl2.compiler.parser.node.Node;
import com.agentfactory.afapl2.compiler.parser.node.NotNode;
import com.agentfactory.afapl2.compiler.parser.node.OntologyNode;
import com.agentfactory.afapl2.compiler.parser.node.PerceptorNode;
import com.agentfactory.afapl2.compiler.parser.node.PlanNode;
import com.agentfactory.afapl2.compiler.parser.node.PredicateNode;
import com.agentfactory.afapl2.compiler.parser.node.ProgramNode;
import com.agentfactory.afapl2.compiler.parser.node.RoleNode;
import com.agentfactory.afapl2.compiler.parser.node.TriggerNode;
/**
 *
 * @author Administrator
 */
public class Phase4Visitor extends Visitor {
    private PrintWriter out;
    
    public Phase4Visitor(List<AFAPL2SyntaxError> errors, List<AFAPL2SyntaxError> warnings, PrintWriter out, Phase2Visitor visitor) {
        super(errors,warnings);
        this.out = out;
    }

    @Override
	public void visit(Node node) {
        if (node instanceof ProgramNode) {
            visit((ProgramNode) node);
        } else if (node instanceof OntologyNode) {
            visit((OntologyNode) node);
        } else if (node instanceof PredicateNode) {
            visit((PredicateNode) node);
        } else if (FunctionNode.class.isInstance(node)) {
            visit((FunctionNode) node);
        } else if (node instanceof PerceptorNode) {
            visit((PerceptorNode) node);
        } else if (node instanceof ActionNode) {
            visit((ActionNode) node);
        } else if (node instanceof ActivityNode) {
            visit((ActivityNode) node);
        } else if (node instanceof AndNode) {
            visit((AndNode) node);
        } else if (node instanceof FOSNode) {
            visit((FOSNode) node);
        } else if (node instanceof EqualNode) {
            visit((EqualNode) node);
        } else if (node instanceof GreaterThanNode) {
            visit((GreaterThanNode) node);
        } else if (node instanceof LessThanNode) {
            visit((LessThanNode) node);
        } else if (node instanceof GoalNode) {
            visit((GoalNode) node);
        } else if (node instanceof BeliefNode) {
            visit((BeliefNode) node);
        } else if (node instanceof NotNode) {
            visit((NotNode) node);
        } else if (node instanceof AlwaysNode) {
            visit((AlwaysNode) node);
        } else if (node instanceof ClassNode) {
            visit((ClassNode) node);
        } else if (node instanceof PlanNode) {
            visit((PlanNode) node);
        } else if (node instanceof ModuleNode) {
            visit((ModuleNode) node);
        } else if (node instanceof ImpliesNode) {
            visit((ImpliesNode) node);
        } else if (node instanceof CommitNode) {
            visit((CommitNode) node);
        } else if (node instanceof RoleNode) {
            visit((RoleNode) node);
        } else if (node instanceof TriggerNode) {
            visit((TriggerNode) node);
        } else {
            throw new RuntimeException("Attempted to visit a Node instance: " + node);
        }
    }
    
    private void visit(ProgramNode node) {
        for (OntologyNode n: node.getOntologies()) {
            n.accept(this);
            out.println();
        }
        for (PerceptorNode n:node.getPerceptors()) {;
            n.accept(this);
            out.println();
        }
        for (ActionNode n:node.getActions()) {;
            n.accept(this);
            out.println();
        }
        for (PlanNode n:node.getPlans()) {;
            n.accept(this);
            out.println();
        }
        for (ModuleNode n:node.getModules()) {;
            n.accept(this);
            out.println();
        }
        for (ModalNode n:node.getBeliefs()) {;
            n.accept(this);
            out.println();
        }
        for (GoalNode n:node.getGoals()) {;
            n.accept(this);
            out.println();
        }
        for (CommitNode n:node.getCommitments()) {;
            n.accept(this);
            out.println();
        }
        for (ImpliesNode n:node.getBeliefRules()) {;
            n.accept(this);
            out.println();
        }
        for (ImpliesNode n:node.getCommitmentRules()) {;
            n.accept(this);
            out.println();
        }
        for (RoleNode n:node.getRoles()) {;
            n.accept(this);
            out.println();
        }
    }
    
    private void visit(PerceptorNode node) {
        out.print("PER ");
        node.getIdentifier().accept(this);
        out.print(" ");
        node.getPerceptor().accept(this);
        
        List onts = node.getOntologies();
        out.print(" " + onts.size());
        Iterator it = onts.iterator();
        while (it.hasNext()) {
            out.print(" " + it.next());
        }
        writeConfiguration(node.getConfiguration());
    }
        
    private void visit(ActionNode node) {
        out.print("ACT ");
        node.getIdentifier().accept(this);
        out.print(" ");
        node.getPreCondition().accept(this);
        
        out.print(" " + node.getPostConditions().size());
        for (Node pcNode:node.getPostConditions()) {
            out.print(" ");
            pcNode.accept(this);
        }
        
        // NOTE: We don't follow the normal approach here because we know that
        // the cardinality is an integer value...
        out.print(" " + node.getCardinality().getFunctor());
        
        List onts = node.getOntologies();
        out.print(" " + onts.size());
        Iterator it = onts.iterator();
        while (it.hasNext()) {
            out.print(" " + it.next());
        }
       
        out.print(" ");
        node.getActionClass().accept(this);
        writeConfiguration(node.getConfiguration());
    }
    
    private void visit(ModuleNode node) {
        out.print("MOD " + node.getName() + " ");
        node.getModuleClass().accept(this);
        writeConfiguration(node.getConfiguration());
    }

    private void writeConfiguration(Map configuration) {
        out.print(" " + configuration.size());
        Object key = null, value = null;
        Iterator it = configuration.keySet().iterator();
        while (it.hasNext()) {
            key = it.next();
            value = (configuration.get(key));
            out.print(" " + key.toString() + "=" + value.toString());
        }
    }
    
    private void visit(ClassNode node) {
        out.print(node.toString());
    }
    
    private void visit(PlanNode node) {
        out.print("PL ");
        node.getIdentifier().accept(this);
        out.print(" ");
        node.getPreCondition().accept(this);
        out.print(" ");
        node.getPostCondition().accept(this);
        out.print(" ");
        node.getPlan().accept(this);
    }
    
    private void visit(ModalNode node) {
        out.print(node.toString() + ";");
    }
    
    private void visit(BeliefNode node) {
        out.print("B ");
        node.getContents().accept(this);
    }
    
    private void visit(GoalNode node) {
        out.print("G ");
        node.getContents().accept(this);
    }
    
    private void visit(ImpliesNode node) {
        if (node.getRHS() instanceof CommitNode) {
            out.print("CR ");
        } else {
            out.print("BR ");
        }
        node.getLHS().accept(this);
        out.print(" ");
        node.getRHS().accept(this);
    }

    private void visit(CommitNode node) {
        out.print("COM ");
        node.getName().accept(this);
        out.print(" ");
        node.getTime().accept(this);
        out.print(" ");
        node.getCondition().accept(this);
        out.print(" ");
        node.getActivity().accept(this);
    }
    
    private void visit(RoleNode node) {
        out.print("R ");
        node.getIdentifier().accept(this);
        
        List list = node.getMentalState();
        out.print(" " + list.size());
        Iterator it = list.iterator();
        while (it.hasNext()) {
            out.print(" ");
            ((Node) it.next()).accept(this);
        }
        list = node.getTriggers();
        out.print(" " + list.size());
        it = list.iterator();
        while (it.hasNext()) {
            out.print(" ");
            ((Node) it.next()).accept(this);
        }
        list = node.getRules();
        out.print(" " + list.size());
        it = list.iterator();
        while (it.hasNext()) {
            out.print(" ");
            ((Node) it.next()).accept(this);
        }
    }
    
    private void visit(FOSNode node) {
        out.print(node.getFunctor() + " " + node.getArguments().size());
        for (FOSNode fos: node.getArguments()) {
            out.print(" ");
            fos.accept(this);
        }
    }
    
    private void visit(AndNode node) {
        out.print("AND " + node.getChildren().size());
        Iterator it = node.getChildren().iterator();
        for ( Node child : node.getChildren() ) {
            out.print(" ");
            child.accept(this);
        }
    }
    
    private void visit(NotNode node) {
        out.print("!");
        node.getContents().accept(this);
    }
    
    private void visit(TriggerNode node) {
        node.getTrigger().accept(this);
    }
    
    private void visit(AlwaysNode node) {
        out.print("AL ");
        node.getContents().accept(this);
    }

    private void visit(EqualNode node) {
        out.print("EQ ");
        node.getLeft().accept(this);
        out.print(" ");
        node.getRight().accept(this);
    }
    
    private void visit(GreaterThanNode node) {
        out.print("GT ");
        node.getLeft().accept(this);
        out.print(" ");
        node.getRight().accept(this);
    }
    
    private void visit(LessThanNode node) {
        out.print("LT ");
        node.getLeft().accept(this);
        out.print(" ");
        node.getRight().accept(this);
    }

    private void visit(OntologyNode node) {
        out.print("ONT " + node.getIdentifier());
        List<PredicateNode> predicates = node.getPredicates();
        out.print(" " + predicates.size());
        for (PredicateNode predicate:predicates) {
            predicate.accept(this);
        }
        List<FunctionNode> functions = node.getFunctions();
        out.print(" " + functions.size());
        for (FunctionNode function:functions) {
            function.accept(this);
        }
    }
    
    private void visit(PredicateNode node) {
        out.print(" " + node.getFunctor() + " " + node.numArguments());
        for (int i=0;i<node.numArguments(); i++) {
            out.print(" " + node.getType(i) + " " + node.getVariable(i));
        }
    }
    
    private void visit(FunctionNode node) {
        out.print(" " + node.getFunctor() + " " + node.getTypes().size());
        for (int i=0;i<node.getTypes().size(); i++) {
            out.print(" " + node.getTypes().get(i) + " " + node.getVariables().get(i));
        }
        out.print(" " + node.getImplementation());
    }
    
    private void visit(ActivityNode node) {
        out.print(" " + node.getFunctor() + " " + node.numArguments());
        for (int i=0;i<node.numArguments(); i++) {
            out.print(" " + node.getType(i) + " " + node.getVariable(i));
        }
    }
}
