/**
 * Title:       LexicalAnalyserException.java
 * Copyright:   Copyright (c) 1996-2004 The Agent Factory Working Group. All rights reserved.
 * Licence:     This file is free software; you can redistribute it and/or modify
 *              it under the terms of the GNU Lesser General Public License as published by
 *              the Free Software Foundation; either version 2.1, or (at your option)
 *              any later version.
 *
 *              This file is distributed in the hope that it will be useful,
 *              but WITHOUT ANY WARRANTY; without even the implied warranty of
 *              MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *              GNU Lesser General Public License for more details.
 *
 *              You should have received a copy of the GNU Lesser General Public License
 *              along with Agent Factory; see the file COPYING.  If not, write to
 *              the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 *              Boston, MA 02111-1307, USA.
 */

package com.agentfactory.afapl2.compiler.parser;

/**
 *
 * @author  Rem Collier
 */
public class LexicalAnalyserException extends Exception {
    private String source;
    private long line;
    
    public LexicalAnalyserException(String source, long line, String message) {
        super(message);
        
        this.source = source;
        this.line = line;
    }
    
    public String getSource() {
    	return source;
    }
    
    public long getLineNumber() {
    	return line;
    }
}
