/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.token.PunctuationToken;
import com.agentfactory.afapl2.compiler.parser.token.Token;

/**
 *
 * @author Administrator
 */
public class BeliefNode extends ModalNode {
    private FOSNode node;
    
    public BeliefNode(FOSNode node) {
      this.node = node;
    }

    public BeliefNode() { /* used by Token.createToken */ }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        // BELIEF construct syntax: BELIEF(<fosNode>)
        
        // Step 1: Check for open bracket "("
        Token token = analyser.getNextToken();
        if (token instanceof PunctuationToken) {
            if (!token.getText().equals("(")) {
                throw new ParseTreeException("Syntax Error in BELIEF", "expected ( but found", token);
            }
        } else {
            // Didn't get punctuation, so we have a serious problem
            throw new ParseTreeException("Syntax Error in BELIEF", "expected ( or , but found", token);
        }
        
        // Step 2: Create an FOS node...
        token = analyser.getNextToken();
        node = FOSNode.createFOS(token, analyser);
        
        // Step 3: Check for an close bracket ")
        token = analyser.getNextToken();
        if (token instanceof PunctuationToken) {
            if (!token.getText().equals(")")) {
                throw new ParseTreeException("Syntax Error in BELIEF", "expected ) but found", token);
            }
        } else {
            // Didn't get punctuation, so we have a serious problem
            throw new ParseTreeException("Syntax Error in BELIEF", "expected ) but found", token);
        }
        
    }
    
    public Node getContents() {
        return node;
    }
    
    @Override
	public String toString() {
        return "BELIEF(" + node.toString() + ")";
    }
}
