/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.token.PunctuationToken;
import com.agentfactory.afapl2.compiler.parser.token.Token;
/**
 *
 * @author Administrator
 */
public class ClassNode extends Node {
    
    public static ClassNode createClassNode(Token token, LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        if (token instanceof PunctuationToken) {
            throw new ParseTreeException("Syntax Error in Class declaration", "expected a class name, but got", token);
        }
        
        ClassNode node = new ClassNode(token.getText());
        node.setInitialToken(token);
        return node;
    }
    
    private String theClass;
    
    /** Creates a new instance of ProgramNode */
    public ClassNode(String theClass) {
        this.theClass = theClass;
    }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
    }
    
    @Override
	public String toString() {
        return theClass;
    }
}
