/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.ParserHelper;

/**
 *
 * @author Administrator
 */
public class EqualNode extends ModalNode {
    private FOSNode left;
    private FOSNode right;
    
    /** Creates a new instance of ProgramNode */
    public EqualNode() {
    }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        // BELIEF construct syntax: GREATER_THAN(<fosNode>, <fosNode>)
        
        // Step 1: Check for open bracket "("
        ParserHelper.punctuationCheck("(", "Syntax Error in EQUAL", "expected ( but found", analyser);
        
        // Step 2: Get the left hand side of the comparison...
        left = FOSNode.createFOS(analyser.getNextToken(), analyser);

        // Step 3: Check for a comma
        ParserHelper.punctuationCheck(",", "Syntax Error in EQUAL(" + left, "expected , but found", analyser);
        
        // Step 4: Get the left hand side of the comparison...
        right = FOSNode.createFOS(analyser.getNextToken(), analyser);
        
        // Step 5: Check for an close bracket ")
        ParserHelper.punctuationCheck(")", "Syntax Error in EQUAL(" + left + "," + right, "expected ) but found", analyser);
    }
    
    @Override
	public String toString() {
        return "EQUAL(" + left + "," + right + ")";
    }
    
    public FOSNode getLeft() {
        return left;
    }
    
    public FOSNode getRight() {
        return right;
    }
}
