/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import java.util.HashMap;
import java.util.Map;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.ParserHelper;
import com.agentfactory.afapl2.compiler.parser.token.Token;

/**
 *
 * @author Administrator
 */
public class ModuleNode extends Node {
    private ClassNode node;
    private String name;
    private Map<String,String> configuration;
    
    /** Creates a new instance of ProgramNode */
    public ModuleNode() {
        configuration = new HashMap<String,String>();
    }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        // LOAD_MODULE construct syntax: LOAD_MODULE <name> <class>
        name = analyser.getNextToken().getText();
        node = ClassNode.createClassNode(analyser.getNextToken(), analyser);
        Token token = analyser.getNextToken();
        if (token.getText().equals("{")) {
            parseConfiguration(analyser);
            token = analyser.getNextToken();
            if (token != null) {
                analyser.back(token);
            }
        
            if ((token == null) || !token.getText().equals(";")) {
                Token temp = Token.createToken(";", -1, null);
                analyser.back(temp);
            }
        } else {
            analyser.back(token);
        }
    }
    
    private void parseConfiguration(LexicalAnalyser analyser) throws ParseTreeException,LexicalAnalyserException {
        String key = null;
        String value = null;
        Token token = analyser.getNextToken();
        while (!token.getText().equals("}")) {
            key = token.getText();
            ParserHelper.punctuationCheck("=", "Syntax Error in configuration of MODULE " + name, "expected = but got", analyser);
            value = analyser.getNextToken().getText();
            ParserHelper.punctuationCheck(";", "Syntax Error in configuration of MODULE " + name, "expected ; but got", analyser);
            token = analyser.getNextToken();
            configuration.put(key, value);
        }
    }
    
    @Override
	public String toString() {
        return "LOAD_MODULE " + name + " " + node.toString();
    }
    
    public String getName() {
        return name;
    }
    
    public ClassNode getModuleClass() {
        return node;
    }
    
    public Map getConfiguration() {
        return configuration;
    }
}
