/*
 * Node.java
 *
 * Created on 13 June 2006, 14:31
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.Visitor;
import com.agentfactory.afapl2.compiler.parser.token.Token;
/**
 *
 * @author Administrator
 */
public abstract class Node {
    public static Node create(Token token, LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        String nodeType = token.getNodeType();
        
        if (nodeType == null) {
            throw new ParseTreeException("Invalid Construct Declaration", "unknown operator", token);
        }
        
        Node node = null;
        try {
            Class nodeClass = Class.forName(nodeType);
            node = (Node) nodeClass.newInstance();
            node.setInitialToken(token);
            node.construct(analyser);
        } catch (ClassNotFoundException cnfe) {
            System.out.println("[Node] Error Creating Node: Could not find class - " + nodeType);
        } catch (IllegalAccessException iae) {
            System.out.println("[Node] Error Creating Node: Could not create class - " + nodeType);
        } catch (InstantiationException ie) {
            System.out.println("[Node] Error Creating Node: Could not create class - " + nodeType);
        }
        
        return node;
    }
    
    private Token initialToken;
    
    /** Creates a new instance of Node */
    public Node() {
    }
    
    public abstract void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException;
    
    public boolean addChild(Node node) {
        return false;
    }
    
    public void accept(Visitor visitor) {
        visitor.visit(this);
    }
    
    public void setInitialToken(Token token) {
        initialToken = token;
    }
    
    public long getLine() {
        return initialToken.getLine();
    }
    
    public String getSource() {
        return initialToken.getReader().toString();
    }
}
