/*
 * ProgramNode.java
 *
 * Created on 13 June 2006, 14:54
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.parser.node;

import com.agentfactory.afapl2.compiler.parser.LexicalAnalyser;
import com.agentfactory.afapl2.compiler.parser.LexicalAnalyserException;
import com.agentfactory.afapl2.compiler.parser.ParseTreeException;
import com.agentfactory.afapl2.compiler.parser.ParserHelper;
import com.agentfactory.afapl2.compiler.parser.token.Token;

/**
 *
 * @author Administrator
 */
public class UntilNode extends ModalNode {
    private ModalNode term;
    private Node condition;
    
    /** Creates a new instance of ProgramNode */
    public UntilNode() {
    }
    
    @Override
	public void construct(LexicalAnalyser analyser) throws LexicalAnalyserException, ParseTreeException {
        // BELIEF construct syntax: BELIEF(<fosNode>)
        
        // Step 1: Check for open bracket "("
        ParserHelper.punctuationCheck("(", "Syntax Error in UNTIL", "expected ( but found", analyser);
        
        // Step 2: Create an FOS node...
        Token token = analyser.getNextToken();
        Node temp = Node.create(token, analyser);
        if (temp instanceof ModalNode) {
            term = (ModalNode) temp;
        } else {
            throw new LexicalAnalyserException(analyser.getSource(), token.getLine(), "Invalid use of NEXT with: " + temp);
        }
        
        // Step 3: Check for a comma
        ParserHelper.punctuationCheck(",", "Syntax Error in UNTIL(" + term, "expected , but got", analyser);
        
        // Step 4: Get condition:
        token = analyser.getNextToken();
        condition = Node.create(token, analyser);
        condition = ParserHelper.checkForLogicOperators(")", condition, token, analyser);
        
        // Step 5: Check for an close bracket ")
        ParserHelper.punctuationCheck(")", "Syntax Error in UNTIL" + term + "," + condition, "expected ) but found", analyser);
    }
    
    
    public Node getTerm() {
        return term;
    }
    
    public Node getCondition() {
        return condition;
    }
    
    @Override
	public String toString() {
        return "UNTIL(" + term + "," + condition + ")";
    }
}
