/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.compiler.typeCheck;

import java.util.List;

import com.agentfactory.afapl2.compiler.parser.node.FOSNode;

/**
 *
 * @author remcollier
 */
public class FunctionTypeChecker implements ITypeChecker {
    private List<String> types;
    private BasicTypeChecker typeChecker;
    
    public FunctionTypeChecker(BasicTypeChecker typeChecker, List<String> types) {
        this.types = types;
        this.typeChecker = typeChecker;
    }
    
    public boolean validate(FOSNode fos) {
        List<FOSNode> arguments = fos.getArguments();
        if (arguments.size() != types.size()) {
            return false;
        }
        
        for (int i=0; i<types.size(); i++) {
            if (!typeChecker.validateTerm(types.get(i), arguments.get(i))) {
                return false;
            }
            
        }
        return true;
    }
}
