package com.agentfactory.afapl2.core.perceptor;

import com.agentfactory.logic.agent.Belief;
import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.platform.core.IPlatformService;

/**
 * Generates beliefs about the services that are available on the agent platform.
 * @author Rem Collier
 */
public class BoundServices extends Perceptor {
    @Override
	public void perceive() {
        for (IPlatformService service: agent.getBoundPlatformServices()) {
            Belief belief = createBelief("boundToService");
            belief.bind("?id", service.getName());
            adoptBelief(belief);
            /*
            if (MessageTransportService.class.isInstance(service)) {
                // Add a MTS Specific belief regarding the address of the
                // service...
                MessageTransportService mts = (MessageTransportService) service;
                adoptBelief("BELIEF(transportAddress(" + mts.getName() +
                            ","  + mts.getAddress() + "))");
            }
            */
        }
    }
}
