package com.agentfactory.afapl2.core.perceptor;

import com.agentfactory.afapl2.interpreter.AbstractAFAPL2Agent;
import com.agentfactory.afapl2.interpreter.ICommitmentManager;
import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.logic.agent.Perceptor;

public class CommitmentPerceptor extends Perceptor {
    @Override
	public void perceive() {
        ICommitmentManager manager = ((AbstractAFAPL2Agent) agent).getCommitmentManager();
        for (Commitment commitment:manager.getCommitments()) {
            adoptBelief("BELIEF(commitment(" + commitment.getTo() +"," +
                        commitment.getStartTime() + "," +
                        commitment.getMaintenanceCondition() + "," +
                        commitment.getActivity().toString() + "))");
        }
    }
}
