package com.agentfactory.afapl2.core.perceptor;

import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.platform.util.FIPAHelper;


/**
 * Perceptor that generates beliefs about its name and base port number.
 * The beliefs take the form :
 * <code> BELIEF(name(?name)) </code> and
 * <code> BELIEF(onPlatform(?host,?port)) </code> respectively.
 *
 * @author Rem Collier
 * @version July 2002
 */
public class SelfPerceptor extends Perceptor {
    /**
     * generates beliefs about its name and platform
     */
    @Override
	public void perceive() {
        adoptBelief("BELIEF(name(" + agent.getName() + "))");
        adoptBelief("BELIEF(" + FIPAHelper.toFOSString(agent.getAgentID()) +" )");
    }
}

