/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger;

import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import com.agentfactory.afapl2.debugger.model.ActionDescription;
import com.agentfactory.afapl2.debugger.model.CommitmentDescription;
import com.agentfactory.afapl2.debugger.model.CommitmentRuleDescription;
import com.agentfactory.afapl2.debugger.model.GoalDescription;
import com.agentfactory.afapl2.debugger.model.PerceptorDescription;
import com.agentfactory.afapl2.debugger.model.PlanDescription;
import com.agentfactory.afapl2.debugger.model.RoleTemplateDescription;
import com.agentfactory.afapl2.interpreter.CompletedActivity;
import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.logic.agent.Ontology;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.TerImplication;
import com.agentfactory.visualiser.impl.DefaultSnapshot;

/**
 *
 * @author remcollier
 */
public class AFAPL2Snapshot extends DefaultSnapshot {
    List<FOS> currentBeliefs;
    List<FOS> temporalBeliefs;
    List<TerImplication> beliefRules;
    List<CommitmentDescription> commitments;
    List<CommitmentDescription> primaryCommitments;
    List<CommitmentRuleDescription> commitmentRules;
    List<ActionDescription> actions;
    List<String> actionSchedule;
    List<CompletedActivity> completedItems;
    List<Ontology> ontologies;
    List<PlanDescription> plans;
    List<GoalDescription> goals;
    List<RoleTemplateDescription> roles;
    List<PerceptorDescription> perceptors;
    Map<String, List<String>> perceptorBeliefs;
    
    public List<FOS> getCurrentBeliefs() {
        return currentBeliefs;
    }

    public List<FOS> getTemporalBeliefs() {
        return temporalBeliefs;
    }

    public List<TerImplication> getBeliefRules() {
        return beliefRules;
    }
    
    public List<CommitmentDescription> getCommitments() {
        return commitments;
    }
    
    public void setCommitments(List<Commitment> commitments) {
        this.commitments = new LinkedList<CommitmentDescription>();
        primaryCommitments = new LinkedList<CommitmentDescription>();
        for (Commitment commitment: commitments) {
            CommitmentDescription desc = new CommitmentDescription(commitments, commitment);
            this.commitments.add(desc);
            if (commitment.getParent() == null) {
                primaryCommitments.add(desc);
            }
        }
    }
        
    public List<CommitmentDescription> getPrimaryCommitments() {
        return primaryCommitments;
    }
    
    public List<CommitmentRuleDescription> getCommitmentRules() {
        return commitmentRules;
    }
    
    public List<ActionDescription> getActions() {
        return actions;
    }
    
    public List<String> getActionSchedule() {
        return actionSchedule;
    }
    
    public List<CompletedActivity> getCompletedItems() {
        return completedItems;
    }
    
    public List<Ontology> getOntologies() {
        return ontologies;
    }
    
    public List<PlanDescription> getPlans() {
        return plans;
    }
    
    public List<GoalDescription> getGoals() {
        return goals;
    }
    
    public List<RoleTemplateDescription> getRoles() {
        return roles;
    }
    
    public List<PerceptorDescription> getPerceptors() {
        return perceptors;
    }
    
    public Map<String, List<String>> getPerceptorBeliefs() {
        return perceptorBeliefs;
    }
    
    public List<String> getPerceptorBeliefs(String filter) {
        return perceptorBeliefs.get(filter);
    }
}
