/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.util.Iterator;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JToolBar;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.afapl2.interpreter.CompletedActivity;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class ActionSchedulePanel extends JPanel implements InspectorPanel {
    private JList scheduled, completed;
    private JTable table;
    
    public ActionSchedulePanel() {
        setLayout(new BorderLayout());
        JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        
        // Scheduled Part
        JPanel panel = new JPanel(new BorderLayout());
        scheduled = new JList(new DefaultListModel());
        JScrollPane scrollPane = new JScrollPane(scheduled);
        panel.add(BorderLayout.CENTER, scrollPane);
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Scheduled:"));
        panel.add(BorderLayout.NORTH, toolbar);
        pane.setTopComponent(panel);
        
        // Completed Part
        panel = new JPanel(new BorderLayout());
        
        DefaultTableModel tableModel = new DefaultTableModel();
        tableModel.addColumn("Activity");
        tableModel.addColumn("Duration");
        tableModel.addColumn("Result");
        table = new JTable(tableModel);
        TableColumn col = table.getColumnModel().getColumn(1);
        col.setMaxWidth(80);
        col = table.getColumnModel().getColumn(2);
        col.setMaxWidth(80);
        scrollPane = new JScrollPane(table);
        panel.add(BorderLayout.CENTER, scrollPane);
        toolbar = new JToolBar();
        toolbar.add(new JLabel("Completed:"));
        panel.add(BorderLayout.NORTH, toolbar);
        pane.setBottomComponent(panel);
        
        this.add(BorderLayout.CENTER, pane);
    }
    
    public void update(ISnapshot _snapshot) {
        AFAPL2Snapshot snapshot = (AFAPL2Snapshot) _snapshot;
        DefaultListModel model = (DefaultListModel) scheduled.getModel();
        model.removeAllElements();
        
        Iterator it = snapshot.getActionSchedule().iterator();
        while (it.hasNext()) {
            model.addElement(it.next());
        }
        
        DefaultTableModel tableModel = (DefaultTableModel) table.getModel();
        int i = tableModel.getRowCount();
        while (i > 0) {
            tableModel.removeRow(--i);
        }
        Object[] rowData = null;
        for (CompletedActivity activity: snapshot.getCompletedItems()) {
            rowData = new Object[3];
            rowData[0] = activity.getActivity();
            rowData[1] = new Long(activity.getDuration());
            rowData[2] = new Boolean(activity.getResult());
            tableModel.addRow(rowData);
        }        
    }

}
