/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;

import javax.swing.DefaultListModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.TerImplication;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class BeliefPanel extends JPanel implements InspectorPanel {
    private JList list;
    private JComboBox filterBox;
    private AFAPL2Snapshot snapshot;
    
    public BeliefPanel() {
        this.setLayout(new BorderLayout());
        
        // Set up the filter
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Filter:"));
        filterBox = new JComboBox();
        filterBox.addItem("--All--");
        filterBox.addItem("Current Beliefs");
        filterBox.addItem("Temporal Beliefs");
        filterBox.addItem("Belief Rules");
        filterBox.addActionListener(new ActionListener() {
           public void actionPerformed(java.awt.event.ActionEvent event) {
               update();
           } 
        });
        toolbar.add(filterBox);
        this.add(BorderLayout.NORTH, toolbar);
        
        list = new JList(new DefaultListModel());        
        JScrollPane pane = new JScrollPane(list);
        this.add(BorderLayout.CENTER, pane);
    }
    
    public synchronized void update(ISnapshot snapshot) {
        this.snapshot = (AFAPL2Snapshot) snapshot;
        update();
    }
    
    private void update() {
        DefaultListModel model = (DefaultListModel) list.getModel();
        model.removeAllElements();
        
        if (filterBox.getSelectedItem().equals("--All--") ||
            filterBox.getSelectedItem().equals("Current Beliefs")) {
            
            for (FOS belief:snapshot.getCurrentBeliefs()) {
                model.addElement(belief);
            }
        }
        
        if (filterBox.getSelectedItem().equals("--All--") ||
            filterBox.getSelectedItem().equals("Temporal Beliefs")) {
            
            for (FOS belief:snapshot.getTemporalBeliefs()) {
                model.addElement(belief);
            }
        }    
        if (filterBox.getSelectedItem().equals("--All--") ||
            filterBox.getSelectedItem().equals("Belief Rules")) {
            
            for (TerImplication rule:snapshot.getBeliefRules()) {
                model.addElement(rule);
            }
        }    
    }
}
