/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.event.MouseListener;
import java.util.Iterator;

import javax.swing.DefaultListModel;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.afapl2.debugger.model.CommitmentDescription;
import com.agentfactory.afapl2.debugger.model.CommitmentRuleDescription;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class CommitmentRulesPanel extends JPanel implements InspectorPanel {
    private JList list;
    private JList commitments;
    private AFAPL2Snapshot snapshot;
    
    public CommitmentRulesPanel() {
        this.setLayout(new BorderLayout());
        
        JSplitPane splitPane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        list = new JList(new DefaultListModel());
        list.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                updateCommitments();
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
        JScrollPane pane = new JScrollPane(list);
        splitPane.setTopComponent(pane);
        commitments = new JList(new DefaultListModel());
        commitments.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                if (mouseEvent.getClickCount() == 2) {
                    CommitmentDescription commitment = (CommitmentDescription) commitments.getSelectedValue();
                    if (commitment != null) {
                        JTabbedPane pane = (JTabbedPane) getParent();
                        int tab = pane.indexOfTab("Commitments");
                        CommitmentsPanel panel = (CommitmentsPanel) pane.getComponentAt(tab);
                        panel.setCommitment(commitment);
                        pane.setSelectedIndex(tab);
                    }
                }
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
        pane = new JScrollPane(commitments);
        JPanel panel = new JPanel();
        panel.setLayout(new BorderLayout());
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Associated Commitments:"));
        panel.add(BorderLayout.NORTH, toolbar);
        panel.add(BorderLayout.CENTER, pane);
        splitPane.setBottomComponent(panel);
        add(BorderLayout.CENTER, splitPane);
    }
   
    public synchronized void update(ISnapshot snapshot) {
        this.snapshot = (AFAPL2Snapshot) snapshot;        
        updateRules();
    }
    
    public synchronized void updateRules() {
        Object selected = list.getSelectedValue();
        DefaultListModel model = (DefaultListModel) list.getModel();
        
        model.clear();
        for (CommitmentRuleDescription rule: this.snapshot.getCommitmentRules()) {
            model.addElement(rule);
        }
        
        if (model.contains(selected)) {
            list.setSelectedValue(selected, true);
        }
        updateCommitments();
    }
    
    private synchronized void updateCommitments() {
        CommitmentRuleDescription selected = (CommitmentRuleDescription) list.getSelectedValue();
        
        DefaultListModel model = (DefaultListModel) commitments.getModel();
        model.clear();
        if (selected != null) {
            Iterator<CommitmentDescription> it = selected.getCommitments().iterator();
            while (it.hasNext()) {
                model.addElement(it.next());
            }
        }
    }

}
