/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.DefaultComboBoxModel;
import javax.swing.DefaultListModel;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JToolBar;

import com.agentfactory.afapl2.debugger.AFAPL2Snapshot;
import com.agentfactory.afapl2.debugger.model.PerceptorDescription;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

/**
 *
 * @author remcollier
 */
public class PerceptorPanel extends JPanel implements InspectorPanel {
    private JList list;
    private JComboBox filterBox;
    private AFAPL2Snapshot snapshot;
    private String filter;
    private boolean updatingFilter;
    
    public PerceptorPanel() {
        this.setLayout(new BorderLayout());
        
        // Set up the filter
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Filter:"));
        filterBox = new JComboBox(new DefaultComboBoxModel());
        updatingFilter = true;
        filterBox.addActionListener(new ActionListener() {
           public void actionPerformed(java.awt.event.ActionEvent event) {
               if (!updatingFilter) {
                   filter = (String) filterBox.getSelectedItem();
                   update();
               }
           } 
        });
        filterBox.addItem("--All--");
        filter = "--All--";
        updatingFilter = false;
        toolbar.add(filterBox);
        this.add(BorderLayout.NORTH, toolbar);
        
        list = new JList(new DefaultListModel());
        JScrollPane pane = new JScrollPane(list);
        this.add(BorderLayout.CENTER, pane);
    }
    
    public void update(ISnapshot _snapshot) {
        snapshot = (AFAPL2Snapshot) _snapshot;
        update();
    }
    
    private synchronized void update() {
        DefaultComboBoxModel filterModel = (DefaultComboBoxModel) filterBox.getModel();
        updatingFilter = true;
        filterModel.removeAllElements();
        filterModel.addElement("--All--");
        for (PerceptorDescription desc:snapshot.getPerceptors()) {
            filterModel.addElement(desc.getIdentifier());
        }
        filterBox.setSelectedItem(filter);
        updatingFilter = false;
        
        DefaultListModel model = (DefaultListModel) list.getModel();
        model.clear();
        
        if (filter.equals("--All--")) {
            for (List<String> beliefs:snapshot.getPerceptorBeliefs().values()) {
                for (String belief: beliefs) {
                    model.addElement(belief);
                }
            }
        } else {
            for (String belief: snapshot.getPerceptorBeliefs((String) filterBox.getSelectedItem())) {
                model.addElement(belief);
            }
        }        
        list.validate();
    }

}
