/*
 * RoleTemplateDescription.java
 *
 * Created on 06 October 2006, 12:45
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.debugger.model;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.agentfactory.afapl2.interpreter.control.RoleTemplate;
import com.agentfactory.afapl2.interpreter.mentalState.CommitmentRule;
import com.agentfactory.afapl2.interpreter.mentalState.Role;

/**
 *
 * @author Administrator
 */
public class RoleTemplateDescription implements Serializable {
    private String identifier;
    private List<String> triggers;
    private List<String> commitmentRules;
    private List<String> instances;
    
    /**
     * Creates a new instance of RoleTemplateDescription based on an
     * existing RoleTemplate.
     *
     * The current version supports only the identifiers, the triggers,
     * and the commitment rules.
     *
     * TODO (Rem Collier): Extend implementation for all aspects of a role
     */
    public RoleTemplateDescription( RoleTemplate template ) {
        identifier = template.getIdentifier().toString();
        
        triggers = new ArrayList<String>();
        for ( Object o : template.getTriggers() ) triggers.add( o.toString() );
        
        commitmentRules = new ArrayList<String>();
        for ( CommitmentRule cr : template.getCommitmentRules() ) commitmentRules.add( cr.toString() );
        
        instances = new ArrayList<String>();
        for ( Role r : template.getInstances() ) instances.add( r.toString() );
    }
    
    public String getIdentifier() {
        return identifier;
    }
    
    public List<String> getTriggers() {
        return triggers;
    }
    
    public List<String> getCommitmentRules() {
        return commitmentRules;
    }
    
    public List<String> getInstances() {
        return instances;
    }
}
