/*
 * PARActivityHandler.java
 *
 * Created on 11 November 2005, 09:53
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.control.cms;
import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.TerAND;

/**
 *
 * @author Administrator
 */
public class SEQActivityHandler extends ActivityHandler {
    private FOS plan;
    private int index;
    
    /** Creates a new instance of PARActivityHandler */
    public SEQActivityHandler() {
        index = 0;
    }
    
    @Override
    public boolean handle() {
        Commitment newCommitment = null;
        TerAND condition = new TerAND();
        condition.add(new FOS("BELIEF(true)"));
        
        if (commitment.getState() == Commitment.STATE_NEW) {
            plan = commitment.getActivity();
            newCommitment = new Commitment(commitment.getTo(), new FOS("?now"), condition, plan.argAt(index++), commitment);
            newCommitment.evaluate();
            addCommitment(newCommitment);
            commitment.update(Commitment.EVENT_ACTIVATED);
        } else if (commitment.getState() == Commitment.STATE_ACTIVE) {
            // DO_NOTHING! Wait for children to complete
        } else if (commitment.getState() == Commitment.STATE_WAITING) {
            newCommitment = new Commitment(commitment.getTo(), new FOS("?now"), condition, plan.argAt(index++), commitment);
            newCommitment.evaluate();
            addCommitment(newCommitment);
            commitment.update(Commitment.EVENT_ACTIVATED);
        } else if (commitment.getState() == Commitment.STATE_REDUNDANT) {
            return false;
        }
        
        return super.handle();
    }
    
    @Override
    public void handleEvent(int event) {
        if (event == Commitment.EVENT_ACTIVATED) {
            commitment.setState(this, Commitment.STATE_ACTIVE);
        } else if (event == Commitment.EVENT_SUCCEEDED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_SUCCEEDED");
        } else if (event == Commitment.EVENT_FAILED) {
            throw new RuntimeException("Commitment: " + commitment + "\nShould not receive event: EVENT_FAILED");
        } else if (event == Commitment.EVENT_CHILD_SUCCEEDED) {
            commitment.removeCompletedChildren();
            if (commitment.getState() == Commitment.STATE_ACTIVE) {
                if (index == plan.numArguments()) {
                    commitment.setState(this, Commitment.STATE_SUCCEEDED);
                } else {
                    commitment.setState(this, Commitment.STATE_WAITING);
                }
            } else {
                throw new RuntimeException("Commitment: " + commitment + "\nNot in active state for EVENT_CHILD_SUCCEEDED");
            }
        } else if (event == Commitment.EVENT_CHILD_FAILED) {
            commitment.removeFailedChildren();
            commitment.setState(this, Commitment.STATE_FAILED);
            commitment.notifyChildren(Commitment.EVENT_PARENT_FAILED);
        } else if (event == Commitment.EVENT_PARENT_FAILED) {
            commitment.notifyChildren(Commitment.EVENT_PARENT_FAILED);
            commitment.setState(this, Commitment.STATE_FAILED);
        } else if (event == Commitment.EVENT_REDUNDANT) {
            commitment.notifyChildren(Commitment.EVENT_REDUNDANT);
            commitment.setState(this, Commitment.STATE_REDUNDANT);
        }
        
        super.handleEvent(event);
    }
}
