
/*
 * CommitmentRuleDecoder.java
 *
 * Created on November 5, 2007, 11:02 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.LogicFactory;
import com.agentfactory.logic.lang.MalformedLogicException;
import com.agentfactory.logic.lang.TerAND;
import com.agentfactory.logic.lang.TerImplication;

/**
 *
 * @author remcollier
 */
public class BeliefRuleDecoder implements Decoder {
    private static final String LOGNAME = BeliefRuleDecoder.class.getName();
    
    static {
        Logger.getLogger(LOGNAME).setLevel(Level.SEVERE);
    }
    
    private List<String> statement;
    private int index;
    private TerImplication rule;
    
    /** Creates a new instance of CommitmentRuleDecoder */
    public BeliefRuleDecoder(List<String> statement, int offset) {
        this.statement = statement;
        index = offset;
    }
    
    public BeliefRuleDecoder(List<String> statement) {
        this(statement, 1);
    }
    
    public void decode() throws DecodeException {
        BeliefSentenceDecoder decoder = new BeliefSentenceDecoder(statement, index);
        decoder.decode();
        TerAND condition = null;
        try {
            Object cond = LogicFactory.create(decoder.getBeliefSentence());
            if (FOS.class.isInstance(cond)) {
                condition = new TerAND();
                condition.add((FOS) cond);
            } else {
                condition = (TerAND) cond;
            }
        } catch (MalformedLogicException mle) {
            Logger.getLogger(LOGNAME).log(Level.SEVERE, "Could not create belief rule: " + statement, mle);
        }
        index = decoder.getOffset();
        
        BeliefDecoder beliefDecoder = new BeliefDecoder(statement, index+1);
        beliefDecoder.decode();
        index = beliefDecoder.getOffset();
        rule = new TerImplication(condition, new FOS(beliefDecoder.getBelief()));
    }
    
    public int getOffset() {
        return index;
    }
    
    public TerImplication getRule() {
        return rule;
    }
}
