/*
 * BeliefSentenceDecoder.java
 *
 * Created on November 5, 2007, 8:21 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * 
 * @author remcollier
 */
public class BeliefSentenceDecoder implements Decoder {
    private static final Logger logger = Logger.getLogger( BeliefSentenceDecoder.class.getName() );

    static {
        logger.setLevel( Level.SEVERE );
    }

    private List<String> statement;
    private int index;
    private StringBuffer buf;

    /** Creates a new instance of BeliefSentenceDecoder */
    public BeliefSentenceDecoder( List<String> statement, int offset ) {
        this.statement = statement;
        index = offset;
        buf = new StringBuffer();
    }

    public void decode() throws DecodeException {
        String keyword = statement.get( index );
        logger.log( Level.WARNING, "[BeliefSentenceDecoder] keyword: " + keyword );
        if ( keyword.equals( "AND" ) ) {
            index++;

            int count = Integer.parseInt( statement.get( index++ ) );
            boolean first = true;
            while ( count > 0 ) {
                if ( first ) {
                    first = false;
                }
                else {
                    buf.append( "&" );
                }
                decode();
                count--;
            }
        }
        else if ( keyword.equals( "!B" ) ) {
            BeliefDecoder decoder = new BeliefDecoder( statement, index + 1 );
            decoder.decode();
            buf.append( "!" );
            buf.append( decoder.getBelief() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "B" ) ) {
            BeliefDecoder decoder = new BeliefDecoder( statement, index + 1 );
            decoder.decode();
            buf.append( decoder.getBelief() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "LT" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.LESS_THAN, statement, index + 1 );
            decoder.decode();
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "!LT" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.LESS_THAN, statement, index + 1 );
            decoder.decode();
            buf.append( "!" );
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "GT" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.GREATER_THAN, statement, index + 1 );
            decoder.decode();
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "!GT" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.GREATER_THAN, statement, index + 1 );
            decoder.decode();
            buf.append( "!" );
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "EQ" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.EQUAL, statement, index + 1 );
            decoder.decode();
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else if ( keyword.equals( "!EQ" ) ) {
            ComparisonDecoder decoder = new ComparisonDecoder( ComparisonDecoder.EQUAL, statement, index + 1 );
            decoder.decode();
            buf.append( "!" );
            buf.append( decoder.getComparison() );
            index = decoder.getOffset();
        }
        else {
            throw new DecodeException( "Unexpected keyword (" + keyword + ") while decoding a belief." );
        }
    }

    public String getBeliefSentence() {
        return buf.toString();
    }

    public int getOffset() {
        return index;
    }
}
