/*
 * CommitmentDecoder.java
 *
 * Created on November 5, 2007, 11:12 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.agentfactory.afapl2.interpreter.mentalState.Commitment;
import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.lang.LogicFactory;
import com.agentfactory.logic.lang.MalformedLogicException;
import com.agentfactory.logic.lang.TerAND;

/**
 * 
 * @author remcollier
 */
public class CommitmentDecoder implements Decoder {
    private static final Logger logger = Logger.getLogger( CommitmentDecoder.class.getName() );

    static {
        logger.setLevel( Level.SEVERE );
    }

    private List<String> statement;
    private int index;
    private Commitment commitment;

    /** Creates a new instance of CommitmentDecoder */
    public CommitmentDecoder( List<String> statement, int offset ) {
        this.statement = statement;
        index = offset;
    }

    public void decode() throws DecodeException {
        FOSDecoder fosDecoder = new FOSDecoder( statement, index );
        fosDecoder.decode();
        FOS to = new FOS( fosDecoder.getFOS() );
        index = fosDecoder.getOffset();

        fosDecoder = new FOSDecoder( statement, index );
        fosDecoder.decode();
        FOS time = new FOS( fosDecoder.getFOS() );
        index = fosDecoder.getOffset();
        logger.log( Level.INFO, "time: " + time );

        logger.log( Level.INFO, "Decoding condition: " + statement.subList( 0, index ) );
        BeliefSentenceDecoder bsDecoder = new BeliefSentenceDecoder( statement, index );
        bsDecoder.decode();

        TerAND condition = null;
        try {
            Object obj = LogicFactory.create( bsDecoder.getBeliefSentence() );
            if ( FOS.class.isInstance( obj ) ) {
                condition = new TerAND();
                condition.add( (FOS) obj );
            }
            else {
                condition = (TerAND) obj;
            }
        }
        catch ( MalformedLogicException mle ) {
            logger.log( Level.SEVERE, "Failed to create maintenance condition: " + statement, mle );
        }
        index = bsDecoder.getOffset();

        fosDecoder = new FOSDecoder( statement, index );
        fosDecoder.decode();
        FOS activity = new FOS( fosDecoder.getFOS() );
        index = fosDecoder.getOffset();

        commitment = new Commitment( to, time, condition, activity );
    }

    public int getOffset() {
        return index;
    }

    public Commitment getCommitment() {
        return commitment;
    }
}
