/*
 * ActionDecoder.java
 *
 * Created on November 5, 2007, 8:36 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.logic.agent.Function;
import com.agentfactory.logic.agent.Ontology;
import com.agentfactory.logic.agent.Predicate;

/**
 *
 * @author remcollier
 */
public class OntologyDecoder implements Decoder {
    private Ontology ontology;
    private List<String> statement;
    private int index;
    
    /** Creates a new instance of ActionDecoder */
    public OntologyDecoder(List<String> statement, int offset) {
        this.statement = statement;
        index = offset;
    }
    
    /** Creates a new instance of ActionDecoder */
    public OntologyDecoder(List<String> statement) {
        this(statement, 1);
    }
    
    public void decode() {
        String ontologyId = statement.get(index++);

        int predicates = Integer.parseInt(statement.get(index++));

        List<Predicate> predicateList = new LinkedList<Predicate>();
        while (predicates > 0) {
            PredicateDecoder decoder = new PredicateDecoder(statement, index);
            decoder.decode();
            index = decoder.getOffset();
            predicateList.add(decoder.getPredicate());
            predicates--;
        }
        
        int functions = Integer.parseInt(statement.get(index++));
        
        List<Function> functionList = new LinkedList<Function>();
        while (functions > 0) {
            FunctionDecoder decoder = new FunctionDecoder(statement, index);
            decoder.decode();
            index = decoder.getOffset();
            functionList.add(decoder.getFunction());
            functions--;
        }
        
        ontology =  new Ontology(ontologyId, predicateList, functionList);
    }
    
    public int getOffset() {
        return index;
    }
    
    public Ontology getOntology() {
        return ontology;
    }
}
