/*
 * ActionDecoder.java
 *
 * Created on November 5, 2007, 8:14 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.agentfactory.afapl2.interpreter.decoder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.agentfactory.logic.MentalAgent;
import com.agentfactory.logic.agent.Perceptor;
import com.agentfactory.logic.lang.FOS;

/**
 *
 * @author remcollier
 */
public class PerceptorDecoder implements Decoder {
    private String percept;
    private FOS id;
    private Map<String,String> configuration;
    private List<String> ontologies;
    
    private List<String> statement;
    private int index;
    
    /** Creates a new instance of ActionDecoder */
    public PerceptorDecoder(List<String> statement, int offset) {
        this.statement = statement;
        ontologies = new ArrayList<String>();
        index = offset;
    }
    
    /** Creates a new instance of ActionDecoder */
    public PerceptorDecoder(List<String> statement) {
        this(statement, 1);
    }
    
    public void decode() {
        FOSDecoder fosDecoder = new FOSDecoder(statement, index);
        fosDecoder.decode();
        id = new FOS(fosDecoder.getFOS());
        index = fosDecoder.getOffset();
        
        percept = statement.get(index++);
        
        int onts = Integer.parseInt(statement.get(index++));
        while (onts > 0) {
            ontologies.add(statement.get(index++));
            onts--;
        }
        
        configuration = new HashMap<String,String>();
        String[] item;
        int items = Integer.parseInt(statement.get(index++));
        while (items > 0) {
            item = statement.get(index++).split("=");
            configuration.put(item[0], item[1]);
            items--;
        }
    }
    
    public Perceptor getPerceptor(MentalAgent agent) {
        Perceptor perceptor = null;
        try {
            Class perceptorClass = Class.forName(percept);
            perceptor = (Perceptor) perceptorClass.newInstance();
            perceptor.setIdentifier(id);
            perceptor.setAgent(agent);
            perceptor.setConfiguration(configuration);
            perceptor.setOntologies(ontologies);
        } catch (Exception e) {
            System.out.println("[PerceptorDecoder] Problem creating Perceptor: " + id);
            e.printStackTrace();
        }
        
        return perceptor;
    }
    
    public int getOffset() {
        return index;
    }
}
