/*
 * Action.java
 *
 * Created on 22 July 2005, 13:55
 */

package com.agentfactory.afapl2.interpreter.mentalState;

import java.util.List;

import com.agentfactory.logic.agent.ActivityIdentifier;
import com.agentfactory.logic.agent.Actuator;
import com.agentfactory.logic.lang.TerAND;

/**
 *
 * @author  Administrator
 */
public class Action implements IActivity {
    private ActivityIdentifier identifier;
    private TerAND preCondition;
    private TerAND postCondition;
    private List<TerAND> postConditions;
    private Actuator actuator;
    private int cardinality;
    private int instances;
    
    public Action(ActivityIdentifier identifier, TerAND preCondition, List<TerAND> postConditions, Actuator actuator, int cardinality) {
        this.identifier = identifier;
        this.preCondition = preCondition;
        this.postCondition = postConditions.get(0);
        this.postConditions = postConditions;
        this.actuator = actuator;
        actuator.setActionIdentifier(identifier);
        this.cardinality = cardinality;
        this.instances = 0;
    }
    
    public ActivityIdentifier getIdentifier() {
        return identifier;
    }
    
    public Actuator getActuator() {
        return actuator;
    }
    
    public TerAND getPreCondition() {
        return preCondition;
    }
    
    public TerAND getPostCondition() {
        return postCondition;
    }
    
    public List<TerAND> getPostConditions() {
        return postConditions;
    }
    
    @Override
	public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append(identifier);
        buf.append(":{").append(preCondition).append(",").append(postCondition);
        buf.append("}:").append(actuator.getClass().getName());
        return buf.toString();
    }
    
    public boolean canPerform() {
        if ((cardinality > 0) && (instances == cardinality)) return false;
        instances++;
        return true;
    }
    
    public void completed() {
        instances--;
    }
    
    public int getCardinality() {
        return cardinality;
    }
    
    public int getInstances() {
        return instances;
    }
}
