/*
 * CommitmentRule.java
 *
 * Created on 25 July 2005, 17:11
 */

package com.agentfactory.afapl2.interpreter.mentalState;

import java.util.ArrayList;

import com.agentfactory.logic.lang.TerAND;
import com.agentfactory.logic.reasoner.SubstitutionSet;
import java.util.List;
/**
 *
 * @author  Administrator
 */
public class CommitmentRule {
    private TerAND situation;
    private Commitment commitment;
    private boolean breakpoint;
    private List<Commitment> commitments;
    
    public CommitmentRule(TerAND lhs, Commitment rhs) {
        commitments = new ArrayList<Commitment>();
        breakpoint = false;
        situation = lhs;
        commitment = rhs;
    }
    
    public TerAND getSituation() {
        return situation;
    }
    
    public Commitment getCommitment() {
        return commitment;
    }
    
    public CommitmentRule apply(SubstitutionSet set) {
        return new CommitmentRule(situation.apply(set), commitment.apply(set));
    }
    
    @Override
	public String toString() {
        return situation.toString() + " => " + commitment.toString();
    }
    
    public void setBreakpoint(boolean _breakpoint) {
        breakpoint = _breakpoint;
    }
    
    public boolean isBreakpointSet() {
        return breakpoint;
    }
    
    public void addCommitment(Commitment commitment) {
        commitments.add(commitment);
    }
    
    public void removeCommitment(Commitment commitment) {
        commitments.remove(commitment);
    }
    
    public List<Commitment> getCommitments() {
        return commitments;
    }
}
