/*
 * Role.java
 *
 * Created on 28 January 2005, 19:18
 */

package com.agentfactory.afapl2.interpreter.mentalState;

import java.util.ArrayList;
import java.util.HashMap;

import com.agentfactory.logic.lang.FOS;
import java.util.List;
import java.util.Map;
/**
 *
 * @author  Administrator
 */
public class Role {
    private FOS identifier;
    private Map<String,String> modules;
    private List<String> actuators;
    private List<String> perceptors;
    private List<CommitmentRule> commitmentRules;
    private List<Commitment> commitments;
    
    public Role(FOS identifier) {
        this.identifier = identifier;
        this.commitmentRules = new ArrayList<CommitmentRule>();
        this.actuators = new ArrayList<String>();
        this.perceptors = new ArrayList<String>();
        this.modules = new HashMap<String,String>();
        this.commitments = new ArrayList<Commitment>();
    }
    
    public void addActuator(String name) {
        actuators.add(name);
    }

    public void addPerceptor(String name) {
        perceptors.add(name);
    }

    public void addModule(String id, String type) {
        modules.put(id, type);
    }

    public void addCommitmentRule(CommitmentRule rule) {
        commitmentRules.add(rule);
    }
    
    public void addCommitment(Commitment commitment) {
        commitments.add(commitment);
    }
    
    @Override
	public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append("ROLE " + identifier.toString());
        return buf.toString();
    }
    
    public FOS getIdentifier() {
        return identifier;
    }
    
    public List<CommitmentRule> getCommitmentRules() {
        return commitmentRules;
    }

    public List<String> getActuators() {
        return actuators;
    }
    
    public List<String> getPerceptors() {
        return perceptors;
    }
    
    public List<Commitment> getCommitments() {
        return commitments;
    }
    
    public void merge(Role role) {
        for (String per : role.getPerceptors() ) {
            addPerceptor( per );
        }
        for (String act : role.getActuators() ) {
            addActuator( act );
        }
        for (CommitmentRule cr : role.getCommitmentRules() ) {
            addCommitmentRule(cr);
        }
    }
}
