package com.agentfactory.agentspeak.compiler;


public class PredicateBuilderVisitor implements AgentSpeakParserVisitor {
	String fos = "";
	
	@Override
	public Object visit(SimpleNode node, Object data) {
		if (node.toString().equals("Predicate")) {
			fos += (String) node.jjtGetValue();

			for (int j=0; j<node.jjtGetNumChildren(); j++) {
				if (node.jjtGetChild(j).toString().equals("Terms")) {
					boolean first = true;
					for (int i=0; i<node.jjtGetChild(j).jjtGetNumChildren(); i++) {
						if (first) {
							fos+= "(";
							first = false;
						} else {
							fos += ",";
						}
						
						visit((SimpleNode) node.jjtGetChild(j).jjtGetChild(i), data);
					}
					if (!first) fos+=")";
				}
				if (node.jjtGetChild(j).toString().equals("Label")) {
					boolean first = true;
					for (int i=0; i<node.jjtGetChild(j).jjtGetNumChildren(); i++) {
						if (first) {
							fos+= "[";
							first = false;
						} else {
							fos += ",";
						}
						
						visit((SimpleNode) node.jjtGetChild(j).jjtGetChild(i), data);
					}
					if (!first) fos+="]";
				}
			}						
		} else if (node.toString().equals("Term")) {
			String term = (String) node.jjtGetValue();
			if (term != null) {
				if (term.startsWith("?")) {
					fos += term;
				} else if (term.equals("+")|term.equals("-")|term.equals("*")|term.equals("/")) {
					visit((SimpleNode) node.jjtGetChild(0), null);
					fos += term;
					visit((SimpleNode) node.jjtGetChild(1), null);
				}
			} else {
				visit((SimpleNode) node.jjtGetChild(0), null);
			}
		} else if (node.toString().equals("TermTypes")) {
			visit((SimpleNode) node.jjtGetChild(0), null);
		} else if (node.toString().equals("Variable")) {
			fos += (String) node.jjtGetValue();
		} else if (node.toString().equals("String")) {
			fos += (String) node.jjtGetValue();
		} else if (node.toString().equals("List")) {
			boolean first = true;
			fos += "[";
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				if (first) {
					first = false;
				} else {
					fos += ",";
				}
				
				visit((SimpleNode) node.jjtGetChild(i), data);
			}
			fos+="]";
		} else if (node.toString().equals("Function")) {
			fos += (String) node.jjtGetValue();
			
			boolean first = true;
			for (int i=0; i<node.jjtGetNumChildren(); i++) {
				if (first) {
					fos+= "(";
					first = false;
				} else {
					fos += ",";
				}
				
				visit((SimpleNode) node.jjtGetChild(i), data);
			}
			if (!first) fos+=")";
		} else {
			System.out.println("Type:" + node.toString());
		}
		
		return fos;
	}

}
