package com.agentfactory.agentspeak.interpreter;

import java.util.Map;

import com.agentfactory.agentspeak.debugger.AgentSpeakStateManagerFactory;
import com.agentfactory.agentspeak.debugger.inspector.AgentSpeakInspectorFactory;
import com.agentfactory.platform.core.ConfigurationException;
import com.agentfactory.visualiser.DebuggerRunConfiguration;

public class AgentSpeakDebugConfiguration extends DebuggerRunConfiguration {
	private String name;
	Map<String, String> designs;
	
	public AgentSpeakDebugConfiguration(String name, Map<String, String> designs) {
		this.name = name;
		this.designs = designs;
	}
	
	public String getName() {
		return name;
	}
	
	public String getDomain() {
		return "agentspeak.ucd.ie";
	}
	
	public void configure() throws ConfigurationException {
		addLanguageSupport(new AgentSpeakInspectorFactory(), new AgentSpeakStateManagerFactory());
		
		super.configure();
		
		addArchitectureFactory(new AgentSpeakArchitectureFactory());
		
        for (String design: designs.keySet()) {
        	addAgent(design, designs.get(design));
        }
	}
}
