package com.agentfactory.astr.interpreter;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.lang.ITerm;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.plans.IPlanStep;


public class ASTRAgent extends AbstractASTRAgent {

	public ASTRAgent(String name) {
		super(name);
		eventQueue.add(new ASEvent(ASEvent.ADDITION, (Predicate) Utilities.factory.createFormula("initialized")));

		List<ASTRRule> rules = new LinkedList<ASTRRule>();
		rules.add(new ASTRRule(Utilities.factory.createFormula("true"), Utilities.factory.createFormula(".println(\"hello world\")")));
		ASTRProgram program = new ASTRProgram("main:0", rules, new LinkedList<ITerm>());
		this.programs.put("main:0",program);
		
		List<IPlanStep> list = new LinkedList<IPlanStep>();
		list.add(new ASTRBasicStep(Utilities.factory.createFormula("tr.start(main)")));
		ASEvent evt = new ASEvent(ASEvent.ADDITION, Utilities.factory.createFormula("initialized"));
		this.addPlanRule(new PlanRule((Predicate) Utilities.factory.createFormula("testRule"),
									  evt,
									  Utilities.factory.createFormula("true"),
									  Utilities.factory.createFormula("true"),
									  list));
		
//		this.activePrograms.add((Predicate) Utilities.factory.createFormula("main"));
//		this.programStacks.put(activePrograms.get(0), new LinkedList<String>());
//		this.actionTraces.put(activePrograms.get(0), new LinkedList<String>());
	}
	
	
}
