/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.astr.interpreter;

import com.agentfactory.platform.core.AgentCreationException;
import com.agentfactory.platform.core.IAgent;
import com.agentfactory.platform.impl.AbstractArchitectureFactory;

/**
 *
 * @author remcollier
 */
public class ASTRArchitectureFactory extends AbstractArchitectureFactory {
    public IAgent create(String name, Object design) throws AgentCreationException {
    	if (String.class.isInstance(design)) {
	        ScriptBasedASTRAgent agent = new ScriptBasedASTRAgent(name);
	        String argument = this.configuration.getProperty("TIMESLICE");
	        if (argument != null) {
	            agent.setTimeSlice(Integer.parseInt(argument));
	        } else {
	        	// DEFAULT TIME SLICE = 100
	            agent.setTimeSlice(100);
	        }
	        agent.construct((String) design);
	        return agent;
    	} else if (ASTRMigrationSnapshot.class.isInstance(design)) {
    		ASTRMigrationSnapshot snapshot = (ASTRMigrationSnapshot) design;
    		MigrationBasedASTRAgent agent = new MigrationBasedASTRAgent(snapshot.getName());
    		agent.construct(snapshot);
    		return agent;
    	}
    	
    	return null;
    }

    public boolean filter(Object design) {
        if (String.class.isInstance(design)) {
            return ((String) design).endsWith(".astr");
        }
        if (ASTRMigrationSnapshot.class.isInstance(design)) {
        	return true;
        }
        return false;
    }
}
