package com.agentfactory.astr.interpreter;

import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.util.DefaultLogicFactory;

public class ASTRLogicFactory extends DefaultLogicFactory {
	@Override
	protected IFormula createCustomFormula(String fos) {
		if (fos.startsWith("?")) {
			return new TestFormula(createFormula(fos.substring(1)));
		} else if (fos.startsWith("+")) {
			return new StateUpdateFormula(StateUpdateFormula.ADDITION, createFormula(fos.substring(1)));
		} else if (fos.startsWith("-")) {
			return new StateUpdateFormula(StateUpdateFormula.REMOVAL, createFormula(fos.substring(1)));
		} else if (fos.startsWith("!")) {
			return new AchievementFormula(createFormula(fos.substring(1)));
		}
		
		return null;
	}
}
