package com.agentfactory.clf.interpreter;

import com.agentfactory.clf.lang.Predicate;

public abstract class Action extends AbstractComponent {
	protected Module module;
   
	@Override
	protected void addBelief(String belief) {
		Predicate predicate = (Predicate) CoreUtilities.factory.createFormula(belief);
		if (predicate.getLabels().isEmpty()) predicate.getLabels().add((Predicate) CoreUtilities.factory.createFormula("source(self)"));
		agent.addBelief(predicate);
	}
	
	public abstract boolean execute(Predicate activity);
	
	protected void setModule( Module module ) {
	   this.module = module;
	}
}
