package com.agentfactory.clf.interpreter;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.clf.lang.Function;
import com.agentfactory.clf.lang.ITerm;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.lang.StringTerm;
import com.agentfactory.clf.util.DefaultLogicFactory;
import com.agentfactory.clf.util.DefaultLogicPresenter;
import com.agentfactory.clf.util.ILogicFactory;
import com.agentfactory.clf.util.ILogicPresenter;
import com.agentfactory.platform.core.AgentID;

public class CoreUtilities {
   public static String createSignature( Predicate fos ) {
      return fos.functor() + ":" + fos.size();
   }

   public static AgentID toAgentID( ITerm term ) {
      if ( !Function.class.isInstance( term ) )
         return null;

      Function fos = (Function) term;
      String id = presenter.toString( fos.termAt( 0 ) );

      id = id.replaceAll( "\"", "" );

      List<String> addresses = new LinkedList<String>();
      Function funct = (Function) fos.termAt( 1 );
      for ( ITerm t : funct ) {
         if ( StringTerm.class.isInstance( t ) ) {
            addresses.add( ( (StringTerm) t ).value() );
         }
         else {
            addresses.add( presenter.toString( t ) );
         }
      }

      return new AgentID( id, addresses, new LinkedList<String>() );
   }

   public static final ILogicFactory factory = new DefaultLogicFactory();
   public static final ILogicPresenter presenter = new DefaultLogicPresenter();

   private static void displayAST( ITerm term, String tabs ) {
      System.out.println( tabs + term.getClass().getName() );
      for ( ITerm t : term.terms() ) {
         displayAST( t, tabs + "\t" );
      }
   }

   public static void displayAST( Predicate predicate ) {
      System.out.println( predicate.functor() );
      for ( ITerm term : predicate.terms() ) {
         displayAST( term, "\t" );
      }
   }
}
