package com.agentfactory.clf.lang;

import com.agentfactory.clf.reasoner.Bindings;

public class Contains extends Comparison {
	public Contains(ITerm left, ITerm right) {
		super(left, right);
	}
	
	@Override
	public IFormula apply(Bindings set) {
		ITerm[] t = new ITerm[2];
		t[0] = left.apply(set);
		t[1] = right.apply(set);
		if (ListTerm.class.isInstance(t[0]) && Function.class.isInstance(t[1])) {
			ListTerm lTerm = (ListTerm) t[0];
			for (ITerm term : lTerm.terms()) {
				if (term.equals(t[1])) {
					return new Predicate("true");
				}
			}
			return new Predicate("false");
		}
		return new Contains(t[0], t[1]);
	}
	
	@Override
	public boolean isFalse() {
		return !isTrue();
	}
	@Override
	public boolean isTrue() {
		if (ListTerm.class.isInstance(left) && Function.class.isInstance(right)) {
			ListTerm lTerm = (ListTerm) left;
			for (ITerm term : lTerm.terms()) {
				if (term.equals(right)) {
					return true;
				}
			}
			return false;
		}
		return false;
	}
}
