package com.agentfactory.clf.lang;

import com.agentfactory.clf.reasoner.Bindings;

public class Equality extends Comparison {
	public Equality(ITerm left, ITerm right) {
		super(left, right);
	}
	
	@Override
	public IFormula apply(Bindings set) {
		ITerm[] t = new ITerm[2];
		t[0] = left.apply(set);
		t[1] = right.apply(set);
		if (t[0].isConstant() && t[1].isConstant()) {
			if (t[0].equals(t[1])) {
				return new Predicate("true");
			} else {
				return new Predicate("false");
			}
		}
		return new Equality(left.apply(set), right.apply(set));
	}
	
	@Override
	public boolean isFalse() {
		return !left.equals(right);
	}
	@Override
	public boolean isTrue() {
		return left.equals(right);
	}
}
