package com.agentfactory.clf.lang;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import com.agentfactory.clf.reasoner.Bindings;


public class Variable implements ITerm {
	private String variable;
	
	public Variable(String variable) {
		this.variable = variable;
	}
	
	public String functor() {
		return variable;
	}
	
	@Override
	public ITerm apply(Bindings set) {
		ITerm term = set.getBinding(this);
		if (term != null) {
			return term;
		}
		return this;
	}

	public boolean isConstant() {
		return false;
	}

    public boolean containsVariable(Variable variable) {
    	return false;
    }
    
	public boolean isDistinctFunction(ITerm term) {
		return false;
	}

	public boolean isCompatibleFunction(ITerm term) {
		return false;
	}
	
    public boolean isNotFunctional(ITerm term) {
		return false;
	}
    
    @Override
    public boolean equals(Object obj) {
    	if (Variable.class.isInstance(obj)) {
    		return variable.equals(((Variable) obj).variable);
    	}
    	return false;
    }

	@Override
	public boolean hasTerms() {
		return false;
	}

	@Override
	public Set<Variable> getVariables() {
		Set<Variable> set= new HashSet<Variable>();
		set.add(this);
		return set;
	}

	public boolean matches(ITerm term) {
		return Variable.class.isInstance(term);
	}

	@Override
	public List<ITerm> terms() {
		return new LinkedList<ITerm>();
	}
}
