package com.agentfactory.clf.plans;

import com.agentfactory.clf.interpreter.AbstractLanguageAgent;
import com.agentfactory.clf.interpreter.CoreUtilities;
import com.agentfactory.clf.lang.IFormula;
import com.agentfactory.clf.lang.Predicate;
import com.agentfactory.clf.reasoner.Bindings;

public class BasicStep implements IPlanStep {
	protected IFormula step;
	
	public BasicStep(IFormula step) {
		this.step = step;
	}
	
	@Override
	public IPlanStep apply(Bindings set) {
		return new BasicStep(step.apply(set));
	}
	
	public IFormula formula() {
		return step;
	}

	public String toString() {
		return toString("");
	}
	
	public String toString(String tabs) {
		return tabs + CoreUtilities.presenter.toString(step);
	}

	@Override
	public void handle(AbstractLanguageAgent agent, PlanStack planStack) {
		IFormula activity = step.apply(planStack.bindings());
		if (Predicate.class.isInstance(activity)){
			if (!agent.performActivity((Predicate) activity)) {
				// NEED TO DEAL WITH SUCCESS OR FAILURE OF ACTIVITY...
				agent.logAction(CoreUtilities.presenter.toString(activity) + " {FAILURE]");
				planStack.fail();
			} else {
				agent.logAction(CoreUtilities.presenter.toString(activity) + " {SUCCESS]");
			}
		}
	}
}
