package com.agentfactory.eis.afapl2;

import java.util.Collection;
import java.util.List;
import java.util.Map;

import com.agentfactory.logic.agent.Perceptor;

import eis.exceptions.NoEnvironmentException;
import eis.exceptions.PerceiveException;
import eis.iilang.Percept;

/**
 * 
 * @author Rem Collier
 */
public class EISSensor extends Perceptor {

	@Override
	public void perceive() {
		EISControlModule eis = (EISControlModule) getModuleByName("eis");
		if (eis == null) {
			adoptBelief("BELIEF(noSuchModule(eis))");
			return;
		}
		if(eis.registered)
			adoptBelief("BELIEF(registeredAgent(" + agent.getName() + "))");
		if(eis.associated)
			adoptBelief("BELIEF(" + eis.association + ")");
		if (eis.service != null)
			adoptBelief("BELIEF(setup(done))");
		else 
			return;
		
		try {
			Map<String, Collection<Percept>> percepts = eis.service.getPercepts(agent);
			for (Collection<Percept> list : percepts.values()) {
				for (Percept percept: list) {
					adoptBelief("BELIEF(" + eis.generateBelief(percept) + ")");
				}
			}
		} catch (PerceiveException e) {
		} catch (NoEnvironmentException e) {
		}
		List<Percept> percepts = eis.service.getAgentEvents(agent);
		while (percepts!=null && !percepts.isEmpty()) {
			adoptBelief("BELIEF(" + eis.generateBelief(percepts.remove(0)) + ")");
		}
	}
}
