/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.agent;

import com.agentfactory.logic.lang.FOS;
import com.agentfactory.logic.reasoner.Substitution;
import com.agentfactory.logic.reasoner.SubstitutionSet;
import java.util.List;

/**
 *
 * @author remcollier
 */
public class Belief {
    private FOS term;
    private List<FOS> variables;
    private SubstitutionSet set;
    
    public Belief(FOS term) {
        this.term = term;
        variables = term.getVariables();
        set = new SubstitutionSet();
    }
    
    public boolean bind(String var, String con) {
        FOS variable = new FOS(var);
        if (variables.contains(variable)) {
            FOS constant = new FOS(con);
            set.addBinding(new Substitution(variable, constant));
            variables.remove(variable);
            return true;
        }
        
        return false;
    }
    
    public boolean hasUnboundVariables() {
        return !variables.isEmpty();
    }
    
    public FOS toBelief() {
        return new FOS("BELIEF(" + term.apply(set) + ")");
    }
}
