/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.logic.agent;

import com.agentfactory.logic.lang.FOS;
import java.io.Serializable;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author remcollier
 */
public class Function implements Serializable {
    private String functor;
    private List<String> variables;
    private List<String> types;
    private String implementation;
    
    /** Creates a new instance of tERM */
    public Function(String functor, List<String> types, List<String> variables, String implementation) {
        this.functor = functor;
        this.types = types;
        this.variables = variables;
        this.implementation = implementation;
    }
    
    public String getFunctor() {
        return functor;
    }
    
    public String getType(int i) {
        return types.get(i);
    }
    
    public String getVariable(int i) {
        return variables.get(i);
    }
    
    public int numVariables() {
        return variables.size();
    }
    
    @Override
    public String toString() {
        StringBuffer buf = new StringBuffer();
        buf.append(functor);
        if (!variables.isEmpty()) {
            buf.append("(");
            boolean first = true;
            for (int i=0;i<variables.size();i++) {
                if (first) first = false;
                else buf.append(",");
                buf.append(types.get(i) + ":" + variables.get(i));
            }
            buf.append(")");
        }
        
        if (implementation != null) {
            buf.append("=>" + implementation);
        }
        
        return buf.toString();
    }
    
    public Object toObject(FOS fos) {
        try {
            IComposite comp = (IComposite) Class.forName(implementation).newInstance();
            comp.fromFOS(fos);
            return comp;
        } catch (InstantiationException ex) {
            Logger.getLogger(Function.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            Logger.getLogger(Function.class.getName()).log(Level.SEVERE, null, ex);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(Function.class.getName()).log(Level.SEVERE, null, ex);
        }
        return null;
    }
}
