package com.agentfactory.logic.update.lang;

import java.util.LinkedList;
import java.util.List;

import com.agentfactory.logic.update.reasoner.IQueryEngine;
import com.agentfactory.logic.update.reasoner.IQueryable;
import com.agentfactory.logic.update.reasoner.QueryResult;
import com.agentfactory.logic.update.reasoner.ResolutionBasedQueryEngine;
import com.agentfactory.logic.update.util.DefaultLogicFactory;
import com.agentfactory.logic.update.util.DefaultLogicPresenter;

public class Test implements IQueryable {
	static DefaultLogicFactory factory = new DefaultLogicFactory();
	static DefaultLogicPresenter presenter = new DefaultLogicPresenter();
	
	public static void main(String[] args) {
		IQueryEngine engine = new ResolutionBasedQueryEngine();
		engine.addSource(new Test());
		
		IFormula p1 = factory.createFormula("wantTower(?t) & ~isTower(?t)");
		QueryResult result = engine.query(p1);
		if (result.found) System.out.println("success");
		else System.out.println("disaster");
		
	}

	List<IFormula> list = new LinkedList<IFormula>();
	
	public Test() {
		list.add(factory.createFormula("wantTower([a,b,c,d,e])"));
		list.add(factory.createFormula("isTower([a])"));
		list.add(factory.createFormula("isTower([b])"));
		list.add(factory.createFormula("isTower([c])"));
		list.add(factory.createFormula("isTower([d])"));
		list.add(factory.createFormula("isTower([e])"));
	}
	
	@Override
	public boolean hasType(String type) {
		return true;
	}

	@Override
	public List<IFormula> query(IFormula query) {
		return list;
	}
}
