package com.agentfactory.logic.update.plans;

import com.agentfactory.logic.update.interpreter.AbstractLanguageAgent;
import com.agentfactory.logic.update.interpreter.CoreUtilities;
import com.agentfactory.logic.update.lang.IFormula;
import com.agentfactory.logic.update.lang.Predicate;
import com.agentfactory.logic.update.reasoner.Bindings;

public class BasicStep implements IPlanStep {
	protected IFormula step;
	
	public BasicStep(IFormula step) {
		this.step = step;
	}
	
	@Override
	public IPlanStep apply(Bindings set) {
		return new BasicStep(step.apply(set));
	}
	
	public IFormula formula() {
		return step;
	}

	public String toString() {
		return CoreUtilities.presenter.toString(step);
	}

	@Override
	public void handle(AbstractLanguageAgent agent, PlanStack planStack) {
		IFormula activity = step.apply(planStack.bindings());
		if (Predicate.class.isInstance(activity)){
			if (!agent.performActivity((Predicate) activity)) {
				// NEED TO DEAL WITH SUCCESS OR FAILURE OF ACTIVITY...
				planStack.fail();
			} else {
				agent.logAction(CoreUtilities.presenter.toString(activity));
			}
		}
	}
	
}
