package com.agentfactory.platform.core;

import java.util.List;
import java.util.Properties;
import java.util.Set;

/**
 * Interface to be implemented by Platform Service Manager implementations
 * @author daithi
 */
public interface IPlatformServiceManager {
    public IPlatformService getServiceByName( String serviceName );
    public void registerService( IPlatformService service );
    public void unregisterService( IPlatformService service );
    public List<IPlatformService> getFilteredServices( Class<? extends IPlatformService> c );
    public boolean bindToService(IAgent agent, IPlatformService service);
    public IAgentPlatform getAgentPlatform();
    public void addService( Class<? extends IPlatformService> serviceClass, String serviceName, int priority, Properties config ) throws NoSuchServiceException;
    public void addService( Class<? extends IPlatformService> serviceClass, String serviceName ) throws NoSuchServiceException;
    public Set<IPlatformService> getServices();
}
