package com.agentfactory.platform.impl;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.agentfactory.platform.core.AgentCreationException;
import com.agentfactory.platform.core.NoSuchArchitectureException;
import com.agentfactory.platform.impl.JavaArchitectureFactory;


public class ArchitectureFactoryTestSuite {
	JavaArchitectureFactory factory;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		factory = new JavaArchitectureFactory();
	}

	@After
	public void tearDown() throws Exception {
	}

	@Test
	public void JavaArchitectureFactoryClassTest() {
		TestAgent agent = (TestAgent) factory.create("rem", TestAgent.class);
		assert(agent.getName().equals("rem"));
	}

	@Test
	public void JavaArchitectureFactoryStringTest() {
		TestAgent agent = (TestAgent) factory.create("rem", "com/agentfactory/platform/impl/TestAgent.java");
		assert(agent.getName().equals("rem"));
	}

	@Test
	public void JavaArchitectureServiceClassTest() {
		ArchitectureService architectureService = new ArchitectureService();
		architectureService.registerArchitectureFactory(factory);
		TestAgent agent = null;
		try {
			agent = (TestAgent) architectureService.createAgent("rem", TestAgent.class);
		} catch (NoSuchArchitectureException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		} catch (AgentCreationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		}
		assert(agent.getName().equals("rem"));
	}

	@Test
	public void JavaArchitectureServiceStringTest() {
		ArchitectureService architectureService = new ArchitectureService();
		architectureService.registerArchitectureFactory(factory);
		TestAgent agent = null;
		try {
			agent = (TestAgent) architectureService.createAgent("rem", "com/agentfactory/platform/impl/TestAgent.java");
		} catch (NoSuchArchitectureException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		} catch (AgentCreationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		}
		assert(agent.getName().equals("rem"));
	}
}
