package com.agentfactory.platform.impl;

import java.util.Properties;

import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;

import com.agentfactory.platform.core.IPlatformService;
import com.agentfactory.platform.core.NoSuchServiceException;


public class PlatformServiceTestSuite {
	PlatformServiceManager platformServiceManager;
	
	@BeforeClass
	public static void setUpBeforeClass() throws Exception {
	}

	@AfterClass
	public static void tearDownAfterClass() throws Exception {
	}

	@Before
	public void setUp() throws Exception {
		// There is no AgentPlatform to pass in, so set it to null.
		platformServiceManager = new PlatformServiceManager(null);
	}

	@After
	public void tearDown() throws Exception {
	}

	public static class TestService extends AbstractPlatformService {
		
	}
	
	@Test
	public void AddServiceTest() {
		try {
			platformServiceManager.addService(TestService.class, "test");
		} catch (NoSuchServiceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		}
		
		IPlatformService service = platformServiceManager.getServiceByName("test");
		assert(TestService.class.isInstance(service));
		assert(service.getName().equals("test"));
	}

	@Test
	public void AddServiceTest2() {
		// This test uses the other addService method which includes a priority (not used) and a
		// properties object that allows the service to be configured.
		try {
			platformServiceManager.addService(TestService.class, "test", 1000, new Properties());
		} catch (NoSuchServiceException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			assert(false);
		}
		
		IPlatformService service = platformServiceManager.getServiceByName("test");
		assert(TestService.class.isInstance(service));
		assert(service.getName().equals("test"));
	}

	@Test
	public void RegisterServiceTest() {
		TestService service = new TestService();
		service.setName("test");
		platformServiceManager.registerService(service);
		
		IPlatformService svc = platformServiceManager.getServiceByName("test");
		assert(svc == service);
	}
}
