/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.rma;

import java.io.Serializable;

/**
 * This class is a data bean that encapsulates a handler event (i.e. the
 * selection and triggering of a handler in response to a message).
 * 
 * @author remcollier
 */
public class HandlerEvent implements Serializable {
    /**
     * The handler class
     */
    private String handler;
    
    /**
     * The message
     */        
    private String message;
    
    /**
     * Whether or not the event was successful
     */
    private boolean outcome;
    
    /**
     * The duration
     */
    private long duration;
    
    /**
     * Creates a new HandlerEvent
     * 
     * @param handler
     * @param message
     * @param duration
     * @param outcome
     */
    public HandlerEvent(String handler, String message, long duration, boolean outcome) {
        this.handler = handler;
        this.message = message;
        this.duration = duration;
        this.outcome = outcome;
    }
    
    public String getHandler() {
        return handler;
    }
    
    public String getMessage() {
        return message;
    }
    
    public long getDuration() {
        return duration;
    }
    
    public boolean getOutcome() {
        return outcome;
    }
}
