package com.agentfactory.rma;

import java.util.Map;

import com.agentfactory.platform.core.ConfigurationException;
import com.agentfactory.rma.debugger.RMAInspectorFactory;
import com.agentfactory.rma.debugger.RMAStateManagerFactory;
import com.agentfactory.visualiser.DebuggerRunConfiguration;

public class RMADebugConfiguration extends DebuggerRunConfiguration {
	private String name;
	Map<String, String> designs;
	
	public RMADebugConfiguration(String name, Map<String, String> designs) {
		this.name = name;
		this.designs = designs;
	}
	
	public String getName() {
		return name;
	}
	
	public String getDomain() {
		return "rma.ucd.ie";
	}
	
	public void configure() throws ConfigurationException {
		addLanguageSupport(new RMAInspectorFactory(), new RMAStateManagerFactory());
		
		super.configure();
		
        for (String design: designs.keySet()) {
        	addAgent(design, designs.get(design));
        }
	}
}
