/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.agentfactory.rma.debugger;

import com.agentfactory.rma.HandlerEvent;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;
import java.awt.BorderLayout;
import java.awt.event.MouseListener;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

/**
 *
 * @author remcollier
 */
public class HandlerEventsPanel extends JPanel implements InspectorPanel {
    private JTable events;
    private JTextArea message;
    private RMASnapshot snapshot;
    
    public HandlerEventsPanel() {
        this.setLayout(new BorderLayout());
        DefaultTableModel model = new DefaultTableModel();
        model.addColumn("Handler");
        model.addColumn("Duration");
        model.addColumn("Outcome");
        
        events = new JTable(model);
        events.addMouseListener(new MouseListener() {
            public void mouseClicked(java.awt.event.MouseEvent mouseEvent) {
                int index = events.getSelectedRow();
                if (index >= 0) {
                    HandlerEvent event = (HandlerEvent) snapshot.getHandledEvents().get(index);
                    message.setText(event.getMessage());
                }
            }
            
            public void mouseReleased(java.awt.event.MouseEvent mouseEvent) {}
            public void mousePressed(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseExited(java.awt.event.MouseEvent mouseEvent) {}
            public void mouseEntered(java.awt.event.MouseEvent mouseEvent) {}
        });
        TableColumn col = events.getColumnModel().getColumn(0);
        col.setMinWidth(200);
        
        message = new JTextArea();
        JPanel panel = new JPanel(new BorderLayout());
        JToolBar toolbar = new JToolBar();
        toolbar.add(new JLabel("Message:"));
        panel.add(BorderLayout.NORTH, toolbar);
        panel.add(BorderLayout.CENTER, new JScrollPane(message));
        JSplitPane pane = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        pane.setDividerLocation(100);
        pane.setTopComponent(new JScrollPane(events));
        pane.setBottomComponent(panel);
        add(BorderLayout.CENTER, pane);
    }
    
    public void update(ISnapshot _snapshot) {
        snapshot = (RMASnapshot) _snapshot;
        
        int selected = events.getSelectedRow();
        
        DefaultTableModel model = (DefaultTableModel) events.getModel();
        int index = model.getRowCount();
        while (index > 0) {
            model.removeRow(--index);
        }
        
        Object[] rowData = null;
        for (HandlerEvent event:snapshot.getHandledEvents()) {
            rowData = new Object[3];
            rowData[0] = event.getHandler();
            rowData[1] = new Long(event.getDuration());
            rowData[2] = new Boolean(event.getOutcome());
            model.addRow(rowData);
        }

        if ((selected > -1) && (selected < model.getRowCount())) {
            String temp = snapshot.getHandledEvents().get(selected).toString();
            if (!message.getText().equals(temp)) {
                message.setText("");
            } else {
                events.setEditingRow(selected);
            }
        } else {
            message.setText("");
        }
    }
}
