package com.agentfactory.smt;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.net.Socket;
import java.net.UnknownHostException;

public class CommandClient {
	private Socket socket;
	private int port;
	private String host;
	private BufferedReader in;
	private PrintStream out;
	private String id;
	
	public CommandClient(String host, int port) {
		this.host = host;
		this.port = port;
	}

	public String id() {
		return id;
	}
	
	public void connect() throws UnknownHostException {
		try {
			socket = new Socket(host, port);
			in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
			out = new PrintStream(socket.getOutputStream());
			
			// Connection protocol: CONNECT -> <platform-name>
			out.println("CONNECT");
			id = in.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public String send(String command) throws IOException {
		out.println(command);
		return in.readLine();
	}
	
	public void disconnect() {
		out.println("CLOSE");
		
		try {
			Thread.sleep(1000);
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		out.close();
		
		try {
			in.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			socket.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
