package com.agentfactory.teleoreactive.debugger;

import com.agentfactory.platform.core.IAgent;
import com.agentfactory.visualiser.core.IStateManager;
import com.agentfactory.visualiser.core.IStateManagerFactory;

public class TeleoReactiveStateManagerFactory implements IStateManagerFactory {
	private int maxHistory;
	
    public void setMaxHistory(int maxHistory) {
    	this.maxHistory = maxHistory;
    }

	@Override
	public IStateManager createStateManager(IAgent agent) {
		IStateManager manager = new TeleoReactiveStateManager();
		manager.setMaxHistory(maxHistory);
		manager.setAgent(agent);
		return manager;
	}

	public String getType() {
		return "AFTeleoReactive";
	}
}
