package com.agentfactory.teleoreactive.debugger.inspector;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import javax.swing.DefaultListModel;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import com.agentfactory.teleoreactive.debugger.TeleoReactiveSnapshot;
import com.agentfactory.visualiser.core.ISnapshot;
import com.agentfactory.visualiser.impl.InspectorPanel;

@SuppressWarnings("serial")
public class BeliefPanel extends JPanel implements InspectorPanel, ActionListener {
    private JList list;
    private TeleoReactiveSnapshot snapshot;
    private RegexPanel rep;
    private JButton b;
    private List<String> filtered;
    
    public BeliefPanel() {
        this.setLayout(new BorderLayout());
        filtered = new LinkedList<String>();
        list = new JList(new DefaultListModel());        
        JScrollPane pane = new JScrollPane(list);
        rep = new RegexPanel();
        rep.setBAL(this);
//        b = new JButton("Get Beliefs");
//        rep.add(b);
//        b.addActionListener(this);
        this.add(BorderLayout.NORTH, rep);
        this.add(BorderLayout.CENTER, pane);
    }
    
    public synchronized void update(ISnapshot snapshot) {
        this.snapshot = (TeleoReactiveSnapshot) snapshot;
        update();
    }
    
    private void update() {
        DefaultListModel model = new DefaultListModel();
        filter(rep.getText());
        Collections.sort(filtered);
        for (String belief:filtered) {
            model.addElement(belief);
        }
        list.setModel(model);
    }

	@Override
	public void actionPerformed(ActionEvent arg0) {
		if(arg0.getSource().equals(b)){
			File f= new File("C:\\Users\\Sean\\beliefs");
			try {
				f.createNewFile();
				FileWriter fr = new FileWriter(f);
				for (String s : snapshot.currentBeliefs) {
					fr.write(s+"\n");
			}
				fr.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
			
			
		} else {
		update();
		
		}
	}
	private void filter(String reg){
		filtered.clear();
		for (String bel : snapshot.currentBeliefs) {
			if(bel.matches(reg)) filtered.add(bel);
		}
	}
	
	
}
