package com.agentfactory.visualiser;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import com.agentfactory.platform.core.AgentID;


/**
 * A utility class to filter on messages stored based on a set of agent IDs.
 * 
 * @author Zhenhua Yang
 *
 */
public class Filter {
	
	private Set<AgentID> filterAIDSet;
	
	public Filter(Set<AgentID> filterAIDSet) {
		this.filterAIDSet = filterAIDSet;
	}
	
	/**
	 * Filter a collection of InteractionRecords based on a set of agent IDs
	 * 
	 * @param ir
	 * 
	 * @return
	 */
	public List<InteractionRecord> filterInteractionRecords(List<InteractionRecord> ir) {
		List<InteractionRecord> results = new ArrayList<InteractionRecord>();
		for (Iterator<InteractionRecord> i = ir.iterator(); i.hasNext();) {
			InteractionRecord log = i.next();
			if (filterAIDSet.contains(log.getSenderSimpleAID()) 
					&& filterAIDSet.containsAll(log.getReceiverSimpleAIDs())) {
				results.add(log);
			}
		}
		return results;
	}

}
