/*
 * NewJInternalFrame.java
 *
 * Created on November 12, 2007, 12:26 PM
 */

package com.agentfactory.visualiser.impl;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextField;

import com.agentfactory.platform.core.IPlatformService;
import com.agentfactory.visualiser.core.IServiceInspectorPanel;

/**
 * 
 * @author remcollier
 */
public class ServiceInspector extends javax.swing.JInternalFrame implements Observer {
   private static final long serialVersionUID = 1L;
   // private IPlatformService service;

   JTabbedPane views;
   JTextField className;

   /** Creates new form NewJInternalFrame */
   public ServiceInspector( IPlatformService service ) {
      // this.service = service;
      this.setTitle( "Agent Inspector on: " + service.getName() );
      this.setResizable( true );
      this.setClosable( true );
      this.setMaximizable( true );
      setLayout( new BorderLayout() );
      add( views = new JTabbedPane(), BorderLayout.CENTER );
      addTab( "Bound Agents", new BoundAgentPanel( service ) );

      JPanel panel = new JPanel( new GridLayout( 1, 2 ) );
      className = new JTextField( service.getClass().getName() );
      className.setEditable( false );
      panel.add( new JLabel( "Implementing Class:" ) );
      panel.add( className );
      add( panel, BorderLayout.NORTH );
      updateView();

      if ( Observable.class.isInstance( service ) ) {
         System.out.println( "Registering observer with: " + service.getName() );
         ( (Observable) service ).addObserver( this );
      }
      pack();
   }

   public void addTab( String name, IServiceInspectorPanel panel ) {
      views.add( name, (JPanel) panel );
   }

   public void update( Observable source, Object event ) {
      updateView();
   }

   private void updateView() {
      for ( int i = 0; i < views.getTabCount(); i++ ) {
         if ( views.getComponentAt( i ) instanceof IServiceInspectorPanel ) {
            ( (IServiceInspectorPanel) views.getComponentAt( i ) ).update();
         }
      }
   }

   public JInternalFrame getInternalFrame() {
      return this;
   }
}
